SystemOrganization addCategory: #'Announcements-Core'!
SystemOrganization addCategory: #'Announcements-Help'!
SystemOrganization addCategory: #'Announcements-Tests-Core'!
SystemOrganization addCategory: #'Announcements-View'!
SystemOrganization addCategory: #Announcements!
SystemOrganization addCategory: #'Announcements-Support'!

Trait named: #TAnnouncer
	uses: {}
	category: 'Announcements-Support'!

!TAnnouncer commentStamp: '<historical>' prior: 0!
A TAnnouncer is 
Just a delagate to get the tipical behavior that should show an object which let you know announcements .
!

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 19:58'!
announce: anAnnouncement 
	self resolveAnnouncer announce:anAnnouncement.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 19:55'!
announcer
	self required.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 19:55'!
announcer: anAnnouncer
	self required.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 20:05'!
removeSubscription: subscription
	^self resolveAnnouncer removeSubscription: subscription.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 19:57'!
resolveAnnouncer
	| announcer | 
	self announcer ifNil: [
		self announcer: Announcer new.	
	].
	^ self announcer.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 20:04'!
subscribe: aAnnouncement do: aBlock
	^self resolveAnnouncer subscribe: aAnnouncement do: aBlock! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 20:04'!
subscribe: anAnnouncementClass send: aSelector to: anObject
	^self resolveAnnouncer subscribe: anAnnouncementClass send: aSelector to: anObject.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/2/2012 20:04'!
unsubscribe: anObject
	^self resolveAnnouncer unsubscribe: anObject.! !

TestCase subclass: #AnnouncementSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementSetTest methodsFor: 'testing' stamp: 'Tbn 11/12/2010 11:07'!
testIncludeOnlyOnce
	|set|
	set := AnnouncementMockA, AnnouncementMockB, AnnouncementMockA.
	self assert: set size = 2! !

!AnnouncementSetTest methodsFor: 'testing' stamp: 'Sd 11/26/2010 17:31'!
testInstanceCreation
	|set|
	set := AnnouncementMockA, AnnouncementMockB.
	self assert: set size = 2 ! !

TestCase subclass: #AnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncerTest commentStamp: 'Tbn 11/12/2010 10:55' prior: 0!
An AnnouncerTest is a test class used to test Announcer.

Instance Variables
	announcer:		<Announcer>  the announcer to test

announcer
	- the announcer that is tested
!

!AnnouncerTest class methodsFor: 'testing' stamp: 'lr 2/26/2011 11:35'!
shouldInheritSelectors
	^ true! !

!AnnouncerTest methodsFor: 'private' stamp: 'lr 2/26/2011 11:34'!
newAnnouncer
	^ Announcer new! !

!AnnouncerTest methodsFor: 'running' stamp: 'lr 2/26/2011 11:34'!
setUp
	super setUp.
	announcer := self newAnnouncer! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:11'!
testAnnounceClass
	self assert: (announcer announce: AnnouncementMockA) 
		class = AnnouncementMockA! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:10'!
testAnnounceInstance
	| instance |
	instance := AnnouncementMockA new.
	self assert: (announcer announce: instance) = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 1/2/2012 15:54'!
testAnnouncingReentrant
	" Test that it is safe to announce when handling announcement,
	so announcer are reentrant "

	" self run: #testAnnouncingReentrant "

	| bool ok |

	ok := bool := false.
	announcer on: Announcement do: [
		bool ifFalse: [
			bool := true.
		announcer announce:  Announcement new. ]
		ifTrue: [ ok := true ] 
	].

	self should: [ announcer announce: Announcement new. ] notTakeMoreThan: 1 second.
	self assert: ok

! !

!AnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 21:47'!
testNoArgBlock
	"we are supposed to accept zero-argument blocks as actions "
	| announcement counter |
	counter := nil.

	self shouldnt: [	
		announcer
			subscribe: AnnouncementMockA 
			do: [ counter:= 1 ] ] raise: Exception.

	self shouldnt: [announcer announce: AnnouncementMockA new] raise: Exception.
	self assert:  counter =1! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:08'!
testSubscribeBlock
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSend
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSet
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockC
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:06'!
testSubscribeSubclass
	| announcement instance |
	announcer
		subscribe: AnnouncementMockB
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement isNil.

	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance.! !

!AnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 21:46'!
testTwoArgBlock
	"we are supposed to accept two-argument blocks as actions "
	| announcement flag |
	
	
	self shouldnt: [
		announcer
			subscribe: AnnouncementMockA 
			do: [:ann :announcer2 | flag := announcer2 == announcer ]
		] raise: Exception.

	self shouldnt: [announcer announce: AnnouncementMockA new] raise: Exception.
	self assert:  flag! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:10'!
testUnsubscribeBlock
	| announcement |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSend
	| announcement receiver |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: (receiver := [ :ann | announcement := ann ]).
	announcer
		unsubscribe: receiver.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSet
	| announcement |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockB
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil.
	
	announcement := nil.
	announcer announce: AnnouncementMockB new.
	self assert: announcement isNil.! !

AnnouncerTest subclass: #WeakAnnouncerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!WeakAnnouncerTest methodsFor: 'benchmarks' stamp: 'IgorStasenko 3/12/2011 21:40'!
benchManyWeakGuys

	| object ann time |
	
	object := Object new.
	ann := Announcer new.
	
	50000 timesRepeat: [ (ann weak on: Announcement send: #value to: object) ].
	
	self assert: (ann numberOfSubscriptions =  50000).
	
	Smalltalk garbageCollect.
	
	time := [object := nil.
		Smalltalk garbageCollect. 
		 ]timeToRun.
	
	self assert: (ann numberOfSubscriptions = 0).
	^ time! !

!WeakAnnouncerTest methodsFor: 'benchmarks' stamp: 'IgorStasenko 3/12/2011 20:41'!
benchWeakSubscriptionDynamic

	" run me to see how expensive becomeForward: is (compared to #benchWeakSubscriptionStatic ) "
	| object ann |
	
	object := Object new.
	ann := Announcer new.
	
	^ [
		1000 timesRepeat: [ (ann on: Announcement send: #value to: object) makeWeak ].
	] timeToRun! !

!WeakAnnouncerTest methodsFor: 'benchmarks' stamp: 'IgorStasenko 3/12/2011 20:42'!
benchWeakSubscriptionStatic

	" run me to see how cheap object creation is (compared to #benchWeakSubscriptionDynamic ) "
	| object ann |
	
	object := Object new.
	ann := Announcer new.
	
	^ [
		1000 timesRepeat: [ (ann weak on: Announcement send: #value to: object)  ].
	] timeToRun! !

!WeakAnnouncerTest methodsFor: 'private' stamp: 'IgorStasenko 3/12/2011 18:16'!
newAnnouncer
	^ Announcer new! !

!WeakAnnouncerTest methodsFor: 'testing' stamp: 'MarcusDenker 8/20/2011 13:43'!
testNoWeakBlock
	"There is no such thing as a weak block, these things never go away."

	<expectedFailure>

	| counter |
	counter := 0.

	(announcer subscribe: AnnouncementMockA do: [ :ann | counter := counter + 1 ]) makeWeak.
	
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 1.
	
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 2! !

!WeakAnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 18:23'!
testWeakObject
	| counter collector forwarder |
	counter := 0.
	collector := [ counter := counter + 1 ].
	forwarder := MessageSend receiver: collector selector: #value.
	(announcer subscribe: AnnouncementMockA send: #value to: forwarder) makeWeak.
	
	" shouldn't go away, we are still holding a reference to 'forwarder': "
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 1.
	
	" should go away as we let the only reference to 'forwarder' go: "
	forwarder := nil.
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 1! !

!WeakAnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 18:27'!
testWeakSubscription
	| obj  subscription |
	
	obj := Object new.
	
	subscription := 
		(announcer on: AnnouncementMockA send: #value to: obj) makeWeak.
		
	self assert: (obj == subscription subscriber).! !

CustomHelp subclass: #AnnouncementsHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Help'!

!AnnouncementsHelp commentStamp: 'Tbn 11/12/2010 11:17' prior: 0!
This is a custom help book for the announcements framework.
!

AnnouncementsHelp subclass: #AnnouncementsAPIDocumentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Help'!

!AnnouncementsAPIDocumentation commentStamp: 'Tbn 11/12/2010 11:17' prior: 0!
This is a custom help book providing the API documentation for the announcements framework.
!

!AnnouncementsAPIDocumentation class methodsFor: 'accessing' stamp: 'Tbn 11/12/2010 10:41'!
bookName
	^'API Documentation'! !

!AnnouncementsAPIDocumentation class methodsFor: 'defaults' stamp: 'Tbn 11/12/2010 10:41'!
builder
	^PackageAPIHelpBuilder! !

!AnnouncementsAPIDocumentation class methodsFor: 'accessing' stamp: 'Tbn 11/12/2010 10:42'!
packages
	^#('Announcements-Core' 'Announcements-View' 'Announcements-Tests-Core')! !

!AnnouncementsHelp class methodsFor: 'accessing' stamp: 'Tbn 11/12/2010 10:35'!
bookName
	^'Announcements framework'! !

!AnnouncementsHelp class methodsFor: 'pages' stamp: 'Tbn 11/12/2010 11:18'!
introduction
	"This method was automatically generated. Edit it using:"
	"AnnouncementsHelp edit: #introduction"
	^HelpTopic
		title: 'Introduction'
		contents: 
'The announcement framwork is an event notification framework. Compared to "traditional" Smalltalk event systems in this new framework, an event is a real object rather than a symbol.

An event someone might want to announce, such as a button click or an attribute change, is defined as a subclass of the abstract superclass Announcement. The subclass can have instance variables for additional information to pass along, such as a timestamp, or mouse coordinates at the time of the event, or the old value of the parameter that has changed. To signal the actual occurrence of an event, the "announcer" creates and configures an instance of an appropriate announcement, then broadcasts that instance. Objects subscribed to receive such broadcasts from the announcer receive a broadcast notification together with the instance. They can talk to the instance to find out any additional information about the event that has occurred.!!'  ! !

!AnnouncementsHelp class methodsFor: 'pages' stamp: 'MarianoMartinezPeck 4/30/2011 15:42'!
links
	"This method was automatically generated. Edit it using:"
	"AnnouncementsHelp edit: #links"
	^HelpTopic
		title: 'Links'
		contents: 'You can get more informations on the framework on the following websites:

http://book.pharo-project.org/book/announcements
				
http://www.cincomsmalltalk.com/userblogs/vbykov/blogView?searchCategory=Announcements%20Framework

http://www.cincomsmalltalk.com/userblogs/vbykov/blogView?entry=3310034894

http://dougedmunds.com/pmwiki.php?n=Pharo.AnnouncementsTutorial
'! !

!AnnouncementsHelp class methodsFor: 'accessing' stamp: 'Tbn 11/12/2010 11:30'!
pages
	^#(introduction AnnouncementsTutorial AnnouncementsAPIDocumentation links)! !

AnnouncementsHelp subclass: #AnnouncementsTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Help'!

!AnnouncementsTutorial commentStamp: 'Tbn 11/12/2010 11:17' prior: 0!
This is a custom help book providing a tutorial for the announcements framework.
!

!AnnouncementsTutorial class methodsFor: 'accessing' stamp: 'Tbn 11/12/2010 11:16'!
bookName
	^'Tutorial'! !

!AnnouncementsTutorial class methodsFor: 'accessing' stamp: 'Tbn 11/12/2010 13:54'!
pages
	^#(step1 step2 step3)! !

!AnnouncementsTutorial class methodsFor: 'pages' stamp: 'Tbn 11/12/2010 12:59'!
step1
	"This method was automatically generated. Edit it using:"
	"AnnouncementsTutorial edit: #step1"
	^HelpTopic
		title: 'Step 1 - Define an announcememt'
		contents: 
'To define an announcement you just have to subclass the Announcement class:

   Announcement subclass: #MyInterestingAnnouncement
   	   instanceVariableNames: ''''
	   classVariableNames: ''''
	   poolDictionaries: ''''
	   category: ''MyApp-Core''
	
If required you can add instance variables to hold data that should be transferred when an announcement is made:

   Announcement subclass: #GameLostAnnouncement
	   instanceVariableNames: ''score''
	   classVariableNames: ''''
	   poolDictionaries: ''''
	   category: ''MyGame-Core''!!' readStream nextChunkText! !

!AnnouncementsTutorial class methodsFor: 'pages' stamp: 'Tbn 11/12/2010 13:55'!
step2
	"This method was automatically generated. Edit it using:"
	"AnnouncementsTutorial edit: #step2"
	^HelpTopic
		title: 'Step 2 - Publishers and subscribers'
		contents: 
'If an object wants to announce an event it needs someone to make the announcement to. This is typically an instance of class Announcer which acts as the mediator between the object that has to announce something (publisher) and one or many (anonymous) subscribers who are interested in the event.

	| announcer |
	announcer := Announcer new.
	announcer announce: MyInterestingAnnouncement new

Using #announce: we can make an announcement - but since nobody is interested yet nothing will happen.

Lets add some consumers/subscribers. Subscribers just register on the Announcer instance to note that they are interested on a particular event/announcement: 

	| announcer |
	announcer := Announcer new.	
	announcer on: MyInterestingAnnouncement send: #open to: Browser.     
	announcer on: MyInterestingAnnouncement send: #inspect to: Smalltalk.    	

So anytime an interesting announcement is made we want to inform the two consumers with a specific message. Still nothing happens - we have to additionally make the announcement:

	| announcer |
	announcer := Announcer new.	
	announcer on: MyInterestingAnnouncement send: #open to: Browser.    
	announcer on: MyInterestingAnnouncement send: #inspect to: Smalltalk.    	
	announcer announce: MyInterestingAnnouncement new	

Note that the subscribers are decoupled from the orginal announcement publisher. They dont have to know each other. Decoupling is the key thing here ... subscribers can register for particular events/announcements and remain anonymous to the original publisher. !!' readStream nextChunkText! !

!AnnouncementsTutorial class methodsFor: 'pages' stamp: 'Tbn 11/12/2010 14:06'!
step3
	"This method was automatically generated. Edit it using:"
	"AnnouncementsTutorial edit: #step3"
	^HelpTopic
		title: 'Step 3 - More examples'
		contents: 
'In Pharo there is a global called "World" pointing to the desktop morph. This world also has an announcer we can use to demonstrate the features of the framework:

	| announcer |
	World announcer 
		on: WindowOpened 
		send: #value 
		to: [ Transcript show: ''A new window was opened'';cr].

So anytime a window is opened in the system a message is shown in the transcript:
		
	Transcript open.
	
	| announcer |
	World announcer 
		on: WindowOpened 
		send: #value 
		to: [:ea | ea inspect. Transcript show: ''A new window was opened'';cr].
!!' readStream nextChunkText! !

Object subclass: #Announcement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!Announcement commentStamp: 'Tbn 11/12/2010 10:57' prior: 0!
This class is the superclass for events that someone might want to announce, such as a button click or an attribute change. Typically you create subclasses for your own events you want to announce.

 
!

!Announcement class methodsFor: 'public' stamp: 'lr 9/20/2006 08:18'!
, anAnnouncementClass
	^ AnnouncementSet with: self with: anAnnouncementClass! !

!Announcement class methodsFor: 'converting' stamp: 'lr 10/3/2006 14:31'!
asAnnouncement
	^ self new! !

!Announcement class methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 17:05'!
handles: anAnnouncementClass
	^ anAnnouncementClass == self or: [ anAnnouncementClass inheritsFrom: self ]! !

!Announcement methodsFor: 'converting' stamp: 'lr 10/3/2006 14:32'!
asAnnouncement
	^ self! !

!Announcement methodsFor: '*Announcements-View' stamp: 'lr 9/3/2006 16:17'!
open
	self inspect! !

Announcement subclass: #AnnouncementMockA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockA commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock.!

Announcement subclass: #AnnouncementMockB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockB commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock!

AnnouncementMockB subclass: #AnnouncementMockC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockC commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock!

Object subclass: #AnnouncementSpy
	instanceVariableNames: 'announcer announcements index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-View'!

!AnnouncementSpy class methodsFor: 'instance-creation' stamp: 'lr 6/14/2006 17:05'!
on: anAnnouncer
	^ self new
		announcer: anAnnouncer;
		yourself! !

!AnnouncementSpy class methodsFor: 'instance-creation' stamp: 'StephaneDucasse 5/1/2011 14:49'!
openOn: anAnnouncer
	"Schedule a new window and open a new AnnouncementSpy on the announcer passed as argument"
	(self on: anAnnouncer) build openInWorld
	! !

!AnnouncementSpy methodsFor: 'private' stamp: 'lr 9/3/2006 14:09'!
announce: anAnnouncement
	self announcements add: anAnnouncement.
	self index: self announcements size.
	self changed: #announcements! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:02'!
announcements
	^ announcements! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 9/3/2006 14:08'!
announcements: aCollection
	announcements := aCollection.
	self changed: #announcements! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:04'!
announcer
	^ announcer! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 9/25/2006 09:26'!
announcer: anAnnouncer
	announcer ifNotNil: [ announcer unsubscribe: self ].
	announcer := anAnnouncer.
	announcer ifNotNil: [ announcer subscribe: Announcement send: #announce: to: self ]! !

!AnnouncementSpy methodsFor: 'building' stamp: 'StephaneDucasse 5/1/2011 14:47'!
build
	"self new build openInWorld"
	|window list|
	window := (SystemWindow labelled: self label) model: self.
	window addMorph: self buildList frame: (0 @ 0 corner: 1 @ 1).
	^ window
	! !

!AnnouncementSpy methodsFor: 'building' stamp: 'StephaneDucasse 5/1/2011 14:47'!
buildList 

	^ (PluggableListMorph new)
				on: self 
				list: #announcements
				selected: #index
				changeSelected: #index:
				menu: #buildMenu: 
				keystroke: nil.
	! !

!AnnouncementSpy methodsFor: 'building' stamp: 'lr 9/3/2006 16:21'!
buildMenu: aMenuMorph
	^ aMenuMorph
		defaultTarget: self;
		add: 'open' action: #open;
		add: 'clear' action: #clear;
		yourself! !

!AnnouncementSpy methodsFor: 'private' stamp: 'lr 6/14/2006 17:19'!
changed: aSymbol
	WorldState addDeferredUIMessage: [ super changed: aSymbol ]! !

!AnnouncementSpy methodsFor: 'actions' stamp: 'lr 9/3/2006 16:21'!
clear
	self announcements: OrderedCollection new! !

!AnnouncementSpy methodsFor: 'actions' stamp: 'lr 9/25/2006 09:19'!
close
	self announcer: nil! !

!AnnouncementSpy methodsFor: 'accessing-dynamic' stamp: 'lr 9/3/2006 14:08'!
extent
	^ 250 @ 400! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:02'!
index
	^ index ! !

!AnnouncementSpy methodsFor: 'accessing' stamp: 'lr 6/14/2006 17:20'!
index: anInteger
	index := anInteger.
	self changed: #index! !

!AnnouncementSpy methodsFor: 'accessing-dynamic' stamp: 'StephaneDucasse 5/1/2011 14:27'!
initialExtent
	^ 300 @ 400! !

!AnnouncementSpy methodsFor: 'initialization' stamp: 'lr 6/14/2006 17:03'!
initialize
	super initialize.
	self announcements: OrderedCollection new.
	self index: 0! !

!AnnouncementSpy methodsFor: 'accessing-dynamic' stamp: 'StephaneDucasse 5/1/2011 14:22'!
label
	^ 'Spy: ', (self announcer ifNil: ['no announcer'] ifNotNil: [ self announcer printString ])
	! !

!AnnouncementSpy methodsFor: 'actions' stamp: 'lr 9/25/2006 09:25'!
open
	(self announcements at: self index ifAbsent: [ ^ self ]) 
		open! !

!AnnouncementSpy methodsFor: 'private' stamp: 'lr 6/14/2006 17:29'!
perform: selector orSendTo: otherTarget
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ super perform: selector orSendTo: otherTarget ]! !

Object subclass: #AnnouncementSubscription
	instanceVariableNames: 'announcer announcementClass subscriber action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!AnnouncementSubscription commentStamp: 'IgorStasenko 3/12/2011 20:23' prior: 0!
The subscription is a single entry in a SubscriptionRegistry.
Several subscriptions by the same object is possible.

I know how to make myself weak or strong, only use this capability if it can't be determined at subscribe time though, as it uses become: (for thread-safety), which is quite slow.!

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:15'!
action

	^ action! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:15'!
action: anObject

	action := anObject! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:18'!
announcementClass

	^ announcementClass! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:18'!
announcementClass: anObject

	announcementClass := anObject! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:15'!
announcer

	^ announcer! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:13'!
announcer: anAnnouncer
	announcer := anAnnouncer! !

!AnnouncementSubscription methodsFor: 'announcing' stamp: 'IgorStasenko 7/17/2011 17:09'!
deliver: anAnnouncement
	" deliver an announcement to receiver. In case of failure, it will be handled in separate process"

	^ (self handles: anAnnouncement class ) ifTrue: [
		[action cull: anAnnouncement cull: announcer] 
			on: UnhandledError fork: [:ex | ex pass ]]! !

!AnnouncementSubscription methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 15:29'!
handles: anAnnouncementClass

	^ announcementClass handles: anAnnouncementClass! !

!AnnouncementSubscription methodsFor: 'converting' stamp: 'IgorStasenko 3/12/2011 17:37'!
makeStrong
	" i am already strong. Do nothing "! !

!AnnouncementSubscription methodsFor: 'converting' stamp: 'IgorStasenko 3/22/2011 15:41'!
makeWeak
	
	action isBlock ifTrue: [
		self error: 'Not currently available due to missing ephemerons support'
		].

	^ announcer replace: self with: 
		(WeakAnnouncementSubscription new
			announcer: announcer;
			action: action asWeakMessageSend;
			subscriber: subscriber;
			announcementClass: announcementClass)! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:14'!
subscriber
	^ subscriber! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:14'!
subscriber: aSubscriber
	subscriber := aSubscriber! !

!AnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 15:16'!
valuable: aValuable
	"Used when subscriber should be extracted from valuable object"
	self action:  aValuable.
	self subscriber: aValuable receiver.! !

Object subclass: #Announcer
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!Announcer commentStamp: 'IgorStasenko 3/12/2011 18:45' prior: 0!
The code is based on the announcements as described by Vassili Bykov in <http://www.cincomsmalltalk.com/userblogs/vbykov/blogView?searchCategory=Announcements%20Framework>. The implementation uses a threadsafe subscription registry, in the sense that registering, unregistering, and announcing from an announcer at the same time in different threads should never cause failures.

For security reasons, registry is kept private, and has no accessor like in other implementations!

!Announcer methodsFor: 'announce' stamp: 'StephaneDucasse 4/24/2011 11:06'!
announce: anAnnouncement

	| announcement |
	announcement := anAnnouncement asAnnouncement.	
	registry ifNotNil: [
		registry deliver: announcement
		].
	^ announcement! !

!Announcer methodsFor: 'private' stamp: 'IgorStasenko 3/12/2011 20:30'!
basicSubscribe: subscription
	^ registry add: subscription! !

!Announcer methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/12/2011 16:50'!
initialize
	super initialize.
	registry := SubscriptionRegistry new.! !

!Announcer methodsFor: 'statistics' stamp: 'IgorStasenko 3/12/2011 21:02'!
numberOfSubscriptions
	^ registry numberOfSubscriptions
! !

!Announcer methodsFor: 'convenience' stamp: 'StephaneDucasse 4/24/2011 12:15'!
on: anAnnouncementClass do: aValuable
	"Declare that when anAnnouncementClass is raised, aValuable is executed."
	
	^ self subscribe: anAnnouncementClass do: aValuable! !

!Announcer methodsFor: 'convenience' stamp: 'StephaneDucasse 4/24/2011 12:08'!
on: anAnnouncementClass send: aSelector to: anObject
	"Declare that when anAnnouncementClass is raised, anObject should receive the message aSelector."

	^ self subscribe: anAnnouncementClass send: aSelector to: anObject! !

!Announcer methodsFor: '*announcements-view' stamp: 'lr 9/20/2006 08:18'!
open
	AnnouncementSpy openOn: self! !

!Announcer methodsFor: 'subscription' stamp: 'StephaneDucasse 4/24/2011 11:09'!
removeSubscription: subscription
	"Remove the given subscription from the receiver"
	
	^ registry remove: subscription
! !

!Announcer methodsFor: 'private' stamp: 'IgorStasenko 3/22/2011 15:27'!
replace: subscription with: newOne
	^ registry replace: subscription with: newOne
! !

!Announcer methodsFor: 'subscription' stamp: 'StephaneDucasse 4/24/2011 12:17'!
subscribe: anAnnouncementClass do: aValuable 
	"Declare that when anAnnouncementClass is raised, aValuable is executed."
	^ registry add: (
		AnnouncementSubscription new 
			announcer: self;
			announcementClass: anAnnouncementClass;
			valuable: aValuable)! !

!Announcer methodsFor: 'subscription' stamp: 'StephaneDucasse 4/24/2011 12:16'!
subscribe: anAnnouncementClass send: aSelector to: anObject
	"Declare that when anAnnouncementClass is raised, anObject should receive the message aSelector."
	
	^ self subscribe: anAnnouncementClass do: (MessageSend receiver: anObject selector: aSelector)! !

!Announcer methodsFor: 'subscription' stamp: 'StephaneDucasse 4/24/2011 12:15'!
unsubscribe: anObject
	"Unsubscribe all subscriptions of anObject from the receiver"
	
	registry removeSubscriber: anObject! !

!Announcer methodsFor: 'weak' stamp: 'IgorStasenko 3/12/2011 20:26'!
weak
	"announcer weak subscribe: foo"
	^ WeakSubscriptionBuilder on: self! !

!Announcer methodsFor: 'convenience' stamp: 'StephaneDucasse 4/24/2011 12:15'!
when: anAnnouncementClass do: aValuable
	"Declare that when anAnnouncementClass is raised, aValuable is executed."
	
	^ self subscribe: anAnnouncementClass do: aValuable! !

Object subclass: #SubscriptionRegistry
	instanceVariableNames: 'subscriptions monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!SubscriptionRegistry commentStamp: 'IgorStasenko 3/12/2011 18:43' prior: 0!
The subscription registry is a threadsafe storage for the subscriptions to an Announcer.

In Pharo, subscriptionsFor: protocol is not implemented.
This is because Announcer does not provide public access to its registery for encapsulation reasons.
(We do not want access to the announcer from action blocks to break encapsulation to other subscribers)!

!SubscriptionRegistry methodsFor: 'add/remove' stamp: 'IgorStasenko 3/12/2011 17:28'!
add: subscription
	^ self protected: [
		subscriptions add: subscription  ]
! !

!SubscriptionRegistry methodsFor: 'announcing' stamp: 'FernandoOlivero 11/3/2011 09:55'!
deliver: anAnnouncement
	|  subsCopy |
	
	"using a copy, so subscribers can unsubscribe from announcer "
	"Use OrderedCollection , so unwind protection is easier"
	subscriptions isEmpty ifTrue:[ ^ self ].
	self protected: [ subsCopy := subscriptions as: OrderedCollection ].
	self deliver: anAnnouncement to: subsCopy! !

!SubscriptionRegistry methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/8/2011 21:41'!
deliver: anAnnouncement to: subs
	
	subs do: 
		[:each | 
		[each deliver: anAnnouncement] 
			"Ensure delivery to remaining announcements"
			ifCurtailed: [self deliver: anAnnouncement to: (subs copyAfter: each)]]! !

!SubscriptionRegistry methodsFor: 'initialize-release' stamp: 'IgorStasenko 1/2/2012 15:13'!
initialize
	monitor := Semaphore forMutualExclusion.
	self reset
! !

!SubscriptionRegistry methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 21:03'!
numberOfSubscriptions
	^ subscriptions size! !

!SubscriptionRegistry methodsFor: 'private' stamp: 'IgorStasenko 1/2/2012 15:14'!
protected: aBlock
	^ monitor critical: [ aBlock value ]! !

!SubscriptionRegistry methodsFor: 'add/remove' stamp: 'IgorStasenko 3/12/2011 17:29'!
remove: subscription
	^ self protected: [
		subscriptions remove: subscription ifAbsent: nil ]

! !

!SubscriptionRegistry methodsFor: 'add/remove' stamp: 'IgorStasenko 3/12/2011 17:29'!
removeSubscriber: subscriber
	
	^ self protected: [
		subscriptions removeAllSuchThat: [:subscription | subscription subscriber == subscriber ]]

! !

!SubscriptionRegistry methodsFor: 'add/remove' stamp: 'IgorStasenko 3/22/2011 15:42'!
replace: subscription with: newOne

	" Note that it will signal an error if subscription is not there "
	self protected: [
		subscriptions remove: subscription.
		subscriptions add: newOne 
	].
	^ newOne! !

!SubscriptionRegistry methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/12/2011 21:29'!
reset
	"subscriber -> subscriptions"
	
	subscriptions := IdentitySet new
	


! !

!SubscriptionRegistry methodsFor: 'iterating' stamp: 'IgorStasenko 3/12/2011 17:30'!
subscriptionsOf: aSubscriber do: aBlock
	| copy |
	
	self protected: [ copy := subscriptions copy ].
	
	copy do: 
		[:subscription | 
			subscription subscriber == aSubscriber 
				ifTrue: [ aBlock value: subscription ]	]
! !

Object weakSubclass: #WeakAnnouncementSubscription
	instanceVariableNames: 'list next announcer announcementClass action'
	classVariableNames: 'FinalizationList'
	poolDictionaries: ''
	category: 'Announcements-Core'!

!WeakAnnouncementSubscription commentStamp: 'IgorStasenko 3/12/2011 20:43' prior: 0!
A WeakAnnouncementSubscription is a subscription which is removed automatically when the subscriber is unreferenced.

No support for ephemerons currently prevents this from working for Block actions (blocks hold their receiver, which is the default subscriber strongly). 

To switch between subscription types, use makeStrong/makeWeak on the subscription returned when initially registering with announcer.


Note, that list and next must be first instance variables.!

WeakAnnouncementSubscription weakSubclass: #LegacyWeakSubscription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!LegacyWeakSubscription commentStamp: 'IgorStasenko 3/12/2011 21:37' prior: 0!
I am a subclass which work when VM does not supports finalization lists.
I am about 3 times slower when it comes to finalizing items!

!LegacyWeakSubscription methodsFor: 'converting' stamp: 'IgorStasenko 3/12/2011 18:32'!
makeStrong

	| sub |
	sub := self subscriber.
	sub ifNil: [ ^ self error: 'Subscriber is nil, cannot make strong subscription' ].
	
	self unregister.

	^ self becomeForward: (AnnouncementSubscription new
		announcer: announcer;
		action: action asMessageSend;
		subscriber: sub;
		announcementClass: announcementClass)
! !

!LegacyWeakSubscription methodsFor: 'finalization' stamp: 'IgorStasenko 3/12/2011 18:19'!
register
	self weakRegistry 
		add: self subscriber executor: self! !

!LegacyWeakSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 20:01'!
subscriber: anObject

	self subscriber ifNotNil: [ self error: 'subscriber already set' ].
	self basicAt: 1 put: anObject.
	self register! !

!LegacyWeakSubscription methodsFor: 'finalization' stamp: 'IgorStasenko 3/12/2011 17:40'!
unregister

	| sub |
	sub := self subscriber.
	sub ifNotNil: [
		self weakRegistry 
			remove: sub ]
		! !

!LegacyWeakSubscription methodsFor: 'finalization' stamp: 'IgorStasenko 3/12/2011 14:16'!
weakRegistry
	^ WeakRegistry default! !

!WeakAnnouncementSubscription class methodsFor: 'finalization support' stamp: 'IgorStasenko 3/12/2011 19:43'!
finalizationList
	
	^ FinalizationList ifNil: [ FinalizationList := WeakFinalizationList new ].! !

!WeakAnnouncementSubscription class methodsFor: 'finalization support' stamp: 'IgorStasenko 3/12/2011 21:35'!
finalizeValues
	
	| head |
	
	head := self finalizationList swapWithNil.
	
	[ head notNil ] whileTrue: [ 
		head finalize.
		head := head next
	].! !

!WeakAnnouncementSubscription class methodsFor: 'class initialization' stamp: 'IgorStasenko 3/14/2011 13:26'!
initialize
	"self initialize"
	
	
	WeakArray 
		removeWeakDependent: self;
		addWeakDependent: self
		
	"Make sure that it is not added twice."! !

!WeakAnnouncementSubscription class methodsFor: 'instance creation' stamp: 'IgorStasenko 3/12/2011 21:32'!
new
	
	^ ((WeakFinalizationList hasNewFinalization
		ifTrue: [ self ] ifFalse: [ LegacyWeakSubscription ] )
			basicNew: 1) initialize! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:57'!
action

	^ action! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:57'!
action: anObject

	action := anObject! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:57'!
announcementClass

	^ announcementClass! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:57'!
announcementClass: anObject

	announcementClass := anObject! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:57'!
announcer

	^ announcer! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:57'!
announcer: anAnnouncer
	announcer := anAnnouncer! !

!WeakAnnouncementSubscription methodsFor: 'announcing' stamp: 'IgorStasenko 7/17/2011 17:08'!
deliver: anAnnouncement
	" deliver an announcement to receiver. In case of failure, it will be handled in separate process"

	^ (self handles: anAnnouncement class ) ifTrue: [
		[action cull: anAnnouncement cull: announcer] 
			on: UnhandledError fork: [:ex | ex pass ]]! !

!WeakAnnouncementSubscription methodsFor: 'finalization' stamp: 'IgorStasenko 3/12/2011 21:21'!
finalize

	announcer removeSubscription: self.
	! !

!WeakAnnouncementSubscription methodsFor: 'error handling' stamp: 'IgorStasenko 3/12/2011 19:58'!
handles: anAnnouncementClass

	^ announcementClass handles: anAnnouncementClass! !

!WeakAnnouncementSubscription methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/12/2011 19:48'!
initialize
	list := self class finalizationList! !

!WeakAnnouncementSubscription methodsFor: 'converting' stamp: 'IgorStasenko 3/22/2011 15:45'!
makeStrong

	| sub |
	sub := self subscriber.
	sub ifNil: [ ^ self error: 'Subscriber is nil, cannot make strong subscription' ].
	
	^ announcer replace: self with: 
		(AnnouncementSubscription new
			announcer: announcer;
			action: action asMessageSend;
			subscriber: sub;
			announcementClass: announcementClass)
! !

!WeakAnnouncementSubscription methodsFor: 'converting' stamp: 'IgorStasenko 3/12/2011 19:55'!
makeWeak
	^ self! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 20:48'!
next
	^ next! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:51'!
subscriber

	^ self basicAt: 1! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:51'!
subscriber: anObject

	self subscriber ifNotNil: [ self error: 'subscriber already set' ].

	self basicAt: 1 put: anObject! !

!WeakAnnouncementSubscription methodsFor: 'accessing' stamp: 'IgorStasenko 3/12/2011 19:58'!
valuable: aValuable
	"Used when subscriber should be extracted from valuable object"
	self action:  aValuable.
	self subscriber: aValuable receiver.! !

Object subclass: #WeakSubscriptionBuilder
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!WeakSubscriptionBuilder commentStamp: 'IgorStasenko 3/12/2011 20:37' prior: 0!
I am a wrapper around an Announcer, used to create weak subscriptions at subscription time.

Use me like this:

anAnnouncer weak subscribe: Announcement send: #foo to: barObject.

I raise an error for block subscriptions, as they require non-existing Ephemeron support to function correctly.!

!WeakSubscriptionBuilder class methodsFor: 'instance creation' stamp: 'IgorStasenko 3/12/2011 20:26'!
on: announcer
	^ self new announcer: announcer! !

!WeakSubscriptionBuilder methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/12/2011 20:24'!
announcer: anAnnouncer
	announcer := anAnnouncer ! !

!WeakSubscriptionBuilder methodsFor: 'wrapped protocol' stamp: 'IgorStasenko 3/12/2011 20:24'!
on: anAnnouncementClass do: aValuable
	^ self subscribe: anAnnouncementClass do: aValuable! !

!WeakSubscriptionBuilder methodsFor: 'wrapped protocol' stamp: 'IgorStasenko 3/12/2011 20:25'!
on: anAnnouncementClass send: aSelector to: anObject
	^ self subscribe: anAnnouncementClass send: aSelector to: anObject! !

!WeakSubscriptionBuilder methodsFor: 'wrapped protocol' stamp: 'IgorStasenko 3/12/2011 20:32'!
subscribe: anAnnouncementClass do: aValuable 
	
	^	announcer basicSubscribe: (
			WeakAnnouncementSubscription new 
				announcer: announcer;
				announcementClass: anAnnouncementClass;
				valuable: aValuable)! !

!WeakSubscriptionBuilder methodsFor: 'wrapped protocol' stamp: 'IgorStasenko 3/12/2011 20:33'!
subscribe: anAnnouncementClass send: aSelector to: anObject
	^ self subscribe: anAnnouncementClass do: (WeakMessageSend receiver: anObject selector: aSelector)! !

!WeakSubscriptionBuilder methodsFor: 'wrapped protocol' stamp: 'IgorStasenko 3/12/2011 20:25'!
weak
	"already weak"
	^ self! !

!WeakSubscriptionBuilder methodsFor: 'wrapped protocol' stamp: 'IgorStasenko 3/12/2011 20:25'!
when: anAnnouncementClass do: aValuable
	^ self subscribe: anAnnouncementClass do: aValuable! !

Set subclass: #AnnouncementSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Core'!

!AnnouncementSet methodsFor: 'adding' stamp: 'lr 6/13/2006 08:13'!
, anAnnouncementClass
	self add: anAnnouncementClass! !

!AnnouncementSet methodsFor: 'testing' stamp: 'lr 10/3/2006 14:31'!
handles: anAnnouncementClass
	^ self anySatisfy: [ :each | each handles: anAnnouncementClass ]! !
WeakAnnouncementSubscription initialize!
